| Demo HCI Implementation for WiMOD-LR Devices V2.0.3

Public Member Functions | Protected Member Functions | List of all members
WiMOD_SAP_RadioLink_ProLink Class Reference

Implementation for the ServiceAccessPoint RadioLink (LR-Base firmware only) More...

`#include <SAP/WiMOD_SAP_RadioLink_ProLink.h>`

Inheritance diagram for WiMOD_SAP_RadioLink_ProLink:
[legend]
Collaboration diagram for WiMOD_SAP_RadioLink_ProLink:
[legend]

## Public Member Functions
| WiMOD_SAP_RadioLink_ProLink (TWiMODLRHCI *hci, UINT8 *buffer, UINT16 bufferSize)
| Constructor. More...
virtual | ~WiMOD_SAP_RadioLink_ProLink (void)
| Destructor. More...
virtual TWiMODLRResultCodes | SendCData (const TWiMODLR_RadioLink_Msg *txMsg, UINT8 *statusRsp)
| Tries to send transmit C-Data to peer module via RF link. More...
virtual bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_RadioLink_CdataInd *cDataTxInfo)
| Convert a received low level HCI-Msg to a high-level CDataTx Info. More...
virtual bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_AckTxInd_Msg *txAckIndInfo)
| Convert a received low level HCI-Msg to a high-level AckTxInd Info. More...
virtual bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_RadioLink_Msg *radioLinkMsg)
| Convert a received low level HCI-Msg to a high-level RadioLink-Msg. More...
virtual bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_RadioLink_UdataInd *uDataTxInfo)
| Convert a received low level HCI-Msg to a high-level UDataTx Info. More...
virtual TWiMODLRResultCodes | SetAckData (const TWiMODLR_RadioLink_Msg *txMsg, UINT8 *statusRsp)
| Sets additional user payload for the next ack frame to send. More...
virtual TWiMODLRResultCodes | SetAesKey (const UINT8 *key, UINT8 *statusRsp)
| SetAesKey Cmd - Set the 128bit AES that is to be used for encryption. More...
virtual TWiMODLRResultCodes | GetAesKey (UINT8 *key, UINT8 *statusRsp)
| GetAesKey Cmd - Get the 128bit AES that that is used for encryption. More...
virtual TWiMODLRResultCodes | GetRadioConfig (TWiMODLR_ProLinkRadioLink_RadioConfig *radioCfg, UINT8 *statusRsp)
| GetRadioConfig Cmd - Get the radio settings of the proprietary LR-BASE mode. More...
virtual TWiMODLRResultCodes | SetRadioConfig (const TWiMODLR_ProLinkRadioLink_RadioConfig *radioCfg, UINT8 *statusRsp)
| SetRadioConfig Cmd - Set the radio settings of the of the proprietary LR-BASE mode. More...
virtual TWiMODLRResultCodes | ResetRadioConfig (UINT8 *statusRsp)
| ResetRadioConfig Cmd - Reset the radio config of the proprietary LR-BASE mode to factory defaults. More...
virtual void | DispatchRadioLinkProLinkMessage (TWiMODLR_HCIMessage &rxMsg)
Public Member Functions inherited from WiMOD_SAP_RadioLink
| WiMOD_SAP_RadioLink (TWiMODLRHCI *hci, UINT8 *buffer, UINT16 bufferSize)
| Constructor. More...
virtual | ~WiMOD_SAP_RadioLink (void)
| Destructor. More...
virtual TWiMODLRResultCodes | SendUData (const TWiMODLR_RadioLink_Msg *txMsg, UINT8 *statusRsp)
| Tries to send transmit U-Data to peer module via RF link. More...
virtual bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_RadioLink_RawMsg *radioLinkRawMsg)
virtual void | RegisterUDataRxClient (TRadioLinkUDataRxIndicationCallback cb)
| Register a callback function for the RX U-Data Indication - optional -. More...
virtual void | RegisterUDataTxClient (TRadioLinkUDataTxIndicationCallback cb)
| Register a callback function for the TX U-Data Indication - optional -. More...
virtual void | RegisterRawDataRxClient (TRadioLinkRawDataRxIndicationCallback cb)
| Register a callback function for the RX Raw-Data Indication - optional -. More...
virtual void | RegisterCDataRxClient (TRadioLinkCDataRxIndicationCallback cb)
| Register a callback function for the RX C-Data Indication - optional -. More...
virtual void | RegisterCDataTxClient (TRadioLinkCDataTxIndicationCallback cb)
| Register a callback function for the TX C-Data Indication - optional -. More...
virtual void | RegisterAckRxClient (TRadioLinkAckRxIndicationCallback cb)
| Register a callback function for the RX Ack (+data) Indication - optional -. More...
virtual void | RegisterAckRxTimeoutClient (TRadioLinkAckRxTimeoutIndicationCallback cb)
| Register a callback function for the Ack Timeout Indication - optional -. More...
virtual void | RegisterAckTxCallback (TRadioLinkAckTxIndicationCallback cb)
| Register a callback function for the TX Ack Indication - optional -. More...
virtual void | DispatchRadioLinkMessage (TWiMODLR_HCIMessage &rxMsg)

## Protected Member Functions
virtual TWiMODLRResultCodes | unsupportedCmd (UINT8 *statusRsp)

## Detailed Description

Implementation for the ServiceAccessPoint RadioLink (LR-Base firmware only)

## Constructor & Destructor Documentation

## ◆ WiMOD_SAP_RadioLink_ProLink()

WiMOD_SAP_RadioLink_ProLink::WiMOD_SAP_RadioLink_ProLink | ( | TWiMODLRHCI * | hci,
|  | UINT8 * | buffer,
|  | UINT16 | bufferSize
| ) |  |

Constructor.

Parameters

  hci | Pointer to HCI processor object
  buffer | pointer to storage area for building tx frames; MUST BE VALID
  bufferSize | size of the buffer

## ◆ ~WiMOD_SAP_RadioLink_ProLink()

WiMOD_SAP_RadioLink_ProLink::~WiMOD_SAP_RadioLink_ProLink | ( | void |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ convert() [1/4]

bool WiMOD_SAP_RadioLink_ProLink::convert | ( | TWiMODLR_HCIMessage & | RxMsg,
|  | TWiMODLR_AckTxInd_Msg * | txAckIndInfo
| ) |  |
| virtual

Convert a received low level HCI-Msg to a high-level AckTxInd Info.

This function should be used by the AckTx Indication Callback functions prior processing the received data message.

Parameters

  RxMsg | Reference to low-level HCI message.

Warning
  DO NOT MANIPULATE THESE VALUES !!!

Parameters

  txAckIndInfo | Pointer to the buffer where to store the received data

Return values

  true | if the conversion was successful

Reimplemented from WiMOD_SAP_RadioLink.

## ◆ convert() [2/4]

bool WiMOD_SAP_RadioLink_ProLink::convert | ( | TWiMODLR_HCIMessage & | RxMsg,
|  | TWiMODLR_RadioLink_CdataInd * | cDataTxInfo
| ) |  |
| virtual

Convert a received low level HCI-Msg to a high-level CDataTx Info.

This function should be used by the Tx-C-Data Indication Callback functions prior processing the received data message.

Parameters

  RxMsg | Reference to low-level HCI message.

Warning
  DO NOT MANIPULATE THESE VALUES !!!

Parameters

  cDataTxInfo | Pointer to the buffer where to store the received data

Return values

  true | if the conversion was successful

Reimplemented from WiMOD_SAP_RadioLink.

## ◆ convert() [3/4]

virtual bool WiMOD_SAP_RadioLink_ProLink::convert | ( | TWiMODLR_HCIMessage & | RxMsg,
|  | TWiMODLR_RadioLink_Msg * | radioLinkMsg
| ) |  |
| inline virtual

Convert a received low level HCI-Msg to a high-level RadioLink-Msg.

This function should be used by the RxUData / RxCData callback functions prior processing the received data message.

Parameters

  RxMsg | Reference to low-level HCI message.

Warning
  DO NOT MANIPULATE THESE VALUES !!!

Parameters

  radioLinkMsg | Pointer to the buffer where to store the received data

Return values

  true | if the conversion was successful

Reimplemented from WiMOD_SAP_RadioLink.

Here is the call graph for this function:

## ◆ convert() [4/4]

virtual bool WiMOD_SAP_RadioLink_ProLink::convert | ( | TWiMODLR_HCIMessage & | RxMsg,
|  | TWiMODLR_RadioLink_UdataInd * | uDataTxInfo
| ) |  |
| inline virtual

Convert a received low level HCI-Msg to a high-level UDataTx Info.

This function should be used by the Tx-U-Data Indication Callback functions prior processing the received data message.

Parameters

  RxMsg | Reference to low-level HCI message.

Warning
  DO NOT MANIPULATE THESE VALUES !!!

Parameters

  uDataTxInfo | Pointer to the buffer where to store the received data

Return values

  true | if the conversion was successful

Reimplemented from WiMOD_SAP_RadioLink.

Here is the call graph for this function:

## ◆ GetAesKey()

TWiMODLRResultCodes WiMOD_SAP_RadioLink_ProLink::GetAesKey | ( | UINT8 * | key,
|  | UINT8 * | statusRsp
| ) |  |
| virtual

GetAesKey Cmd - Get the 128bit AES that that is used for encryption.

Parameters

  key | pointer where to store the 128bit AES key (pointer to array of 16 UINT8 entries)
  statusRsp | pointer to store status byte of response mesg from WiMOD

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

## ◆ GetRadioConfig()

TWiMODLRResultCodes WiMOD_SAP_RadioLink_ProLink::GetRadioConfig | ( | TWiMODLR_ProLinkRadioLink_RadioConfig * | radioCfg,
|  | UINT8 * | statusRsp
| ) |  |
| virtual

GetRadioConfig Cmd - Get the radio settings of the proprietary LR-BASE mode.

Parameters

  radioCfg | pointer to store the received information
  statusRsp | pointer to store status byte of response mesg from WiMOD

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

## ◆ ResetRadioConfig()

TWiMODLRResultCodes WiMOD_SAP_RadioLink_ProLink::ResetRadioConfig | ( | UINT8 * | statusRsp | ) |
| virtual

ResetRadioConfig Cmd - Reset the radio config of the proprietary LR-BASE mode to factory defaults.

Parameters

  statusRsp | pointer to store status byte of response mesg from WiMOD

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

## ◆ SendCData()

TWiMODLRResultCodes WiMOD_SAP_RadioLink_ProLink::SendCData | ( | const TWiMODLR_RadioLink_Msg * | txMsg,
|  | UINT8 * | statusRsp
| ) |  |
| virtual

Tries to send transmit C-Data to peer module via RF link.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  txMsg | Data structure containing the TX-data and options.

See also
  TWiMODLR_RadioLink_Msg for details

Parameters

  statusRsp | Status byte contained in the local response of the module

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

Reimplemented from WiMOD_SAP_RadioLink.

## ◆ SetAckData()

TWiMODLRResultCodes WiMOD_SAP_RadioLink_ProLink::SetAckData | ( | const TWiMODLR_RadioLink_Msg * | txMsg,
|  | UINT8 * | statusRsp
| ) |  |
| virtual

Sets additional user payload for the next ack frame to send.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  txMsg | Pointer to data structure containing the payload data. note: Max ack payload size is 8 byte!

See also
  TWiMODLR_RadioLink_Msg for details

Parameters

  statusRsp | Status byte contained in the local response of the module

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

Reimplemented from WiMOD_SAP_RadioLink.

## ◆ SetAesKey()

TWiMODLRResultCodes WiMOD_SAP_RadioLink_ProLink::SetAesKey | ( | const UINT8 * | key,
|  | UINT8 * | statusRsp
| ) |  |
| virtual

SetAesKey Cmd - Set the 128bit AES that is to be used for encryption.

Parameters

  key | pointer to the 128bit AES key (pointer to array of 16 UINT8 entries)
  statusRsp | pointer to store status byte of response mesg from WiMOD

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

## ◆ SetRadioConfig()

TWiMODLRResultCodes WiMOD_SAP_RadioLink_ProLink::SetRadioConfig | ( | const TWiMODLR_ProLinkRadioLink_RadioConfig * | radioCfg,
|  | UINT8 * | statusRsp
| ) |  |
| virtual

SetRadioConfig Cmd - Set the radio settings of the of the proprietary LR-BASE mode.

Parameters

  radioCfg | pointer to the new radio configuration
  statusRsp | pointer to store status byte of response mesg from WiMOD

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

The documentation for this class was generated from the following files:

- SAP/WiMOD_SAP_RadioLink_ProLink.h
- SAP/WiMOD_SAP_RadioLink_ProLink.cpp